%
% Statistical Signal Processing, October 2022
% (c) AJF
%

% this is for Group 1
zer1 = 0.5;
zer2 = -0.8;
zer3 = 0.8*exp(1j*pi/4);
zer4 = 0.8*exp(-1j*pi/4);
h1 = poly([zer1 zer2 zer3 zer4]);
zplane(h1,1)
pause

% this is for Group 2
zer1 = -0.5;
zer2 = 0.5;
zer3 = 0.8*exp(1j*3*pi/4);
zer4 = 0.8*exp(-1j*3*pi/4);
h2 = poly([zer1 zer2 zer3 zer4]);
zplane(h2,1)
pause

% this is for Group 3
zer1 = 0.8*exp(1j*pi/4);
zer2 = 0.8*exp(-1j*pi/4);
zer3 = 0.5*exp( 1j*5*pi/6);
zer4 = 0.5*exp(-1j*5*pi/6);
h3 = poly([zer1 zer2 zer3 zer4]);
zplane(h3,1)
pause

% this is for Group 4
zer1 = 0.5*exp( 1j*pi/6);
zer2 = 0.5*exp(-1j*pi/6);
zer3 = 0.8*exp( 1j*2*pi/3);
zer4 = 0.8*exp(-1j*2*pi/3);
h4 = poly([zer1 zer2 zer3 zer4]);
zplane(h4,1)
pause


%
% here we ganerate the random excitation
%

N=1E5;
maxlag=4;

% choose either Gaussian or uniform PDF
x=randn(N,1);
%x=rand(N,1)-0.5;

sigma=sqrt(x.'*x);
x=x/sigma;

% to confirm that rx[ell]=DELTA[ell]
[rx, lag]=xcorr(x, maxlag);
stem(lag, rx)
xlabel('$$\ell$$ (samples)','Interpreter', 'Latex');
ylabel('$$r_{X}[\ell]$$','Interpreter', 'Latex');
pause


% now estimate h[n] using ryx[k]


% now estimate h[n] using ry[k]
% 
% remember that in this case you must:
%  * find the roots of ry[k] using roots()
%  * pick the roots of interest
%  * obtain h[n] using the roots of interest using poly()
%
